#include <gtk/gtk.h>
#include <stdio.h>
#include "life.h"
#include "callbacks.h"

microobType actMicrobType = mRed;
playerSpecs *actMicrobs,*oldMicrobs,*old2Microbs;
gint infinityChecking = TRUE;       
gint runningSimulation = FALSE;        
guint32 mainLoopInterval = 100;  
gint levelOfGeneration = 0;
struct rules rulez;
generation *firstGen = NULL;

playerSpecs *doomOfDeath (playerSpecs *p)
{
  int i,ii;
  g_print ("doomOfdeath(%p)\n",p);  
  for (i=0;i<MAX_POP;i++) {
    for (ii=0;ii<MAX_POP;ii++) {
      (*p)[ii][i] = mDied;
    }
  }
  return p;
} 

int mCount  (microobType type, playerSpecs *p)
{
  int count=0;
  int i,ii;
  for (i=0;i<MAX_POP;i++) {
    for (ii=0;ii<MAX_POP;ii++) {
      if ((*p)[ii][i] == type) count++; 
    }
  }
  return count;
}

int saveMap (const char *filename)
{
  FILE *map;
  int status=0,i=0,ii=0;
  generation *g = firstGen;
  map = fopen (filename,"wb");
  
  if (map) {
    status = fwrite (&rulez,sizeof(rules),1,map);
    g_print ("Map saving (part 1/%d) - rulez: %d\n",levelOfGeneration+3,status);
    status = fwrite (&levelOfGeneration,sizeof(gint),1,map);
    g_print ("Map saving (part 2/%d) - level: %d\n",levelOfGeneration+3,status);
    for (i=0;i<levelOfGeneration; i++) {
      g = firstGen; 
      for (ii=1;ii<levelOfGeneration-i;ii++) {
        g = g->next;
      }
      status = fwrite (g->playerGeneration,sizeof(playerSpecs),1,map);
      g_print ("Map saving (part %d/%d): %d\n",i+2,levelOfGeneration+3,status);
    }
    status = fwrite (actMicrobs,sizeof(playerSpecs),1,map);
    g_print ("Map saving (part %d/%d): %d\n",i+2,levelOfGeneration+3,status);
    fclose (map);
    if (status != 1) 
      return 1;
    else 
      return 0;
  }
  else {
    g_print ("Chyba\n");
    return 1;
  }
}

playerSpecs *loadMap (const char *filename, playerSpecs *p)
{
  FILE *map;
  int status,i;
  playerSpecs *g;
  
  g = malloc (sizeof(*g));
  
  if (!g) {
    g_print ("Genereal error has occoured at life.c<loadMap>\nAborting...\n");
  }
  
  map = fopen (filename,"rb");
  
  for (i=0;i<levelOfGeneration;i++) {
    getLastGeneration(&firstGen);
  }
  
  firstGen = NULL;
  
  if (map) {
    status = fread (&rulez,sizeof(rules),1,map);
    g_print ("Map loading (part 1/<unknown>) - rulez: %d\n",status);
    status = fread (&levelOfGeneration,sizeof(gint),1,map);
    g_print ("Map loading (part 2/<unknown>) - level: %d\n",status);
    for (i=0;i<levelOfGeneration; i++) {
      status = fread (g,sizeof(playerSpecs),1,map);
      g_print ("Map loading (part %d/%d): %d\n",i,levelOfGeneration+1,status);
      addGeneration(&firstGen,g);
    }
    status = fread (g,sizeof(playerSpecs),1,map);
    g_print ("Map loading (part %d/%d): %d\n",i+1,levelOfGeneration+1,status);
    fclose (map);
    if (status != 1) 
      return 0;
    else 
      return g;
  }
  else {
    g_print ("Chyba\n");
    return 0;
  }
}

int isAlive(microobType S)      
{
  if (S != mDied) { 
    g_print ("isAliave(): %d\n",S);
    return TRUE;
  }
  else
    return 0;
}

int microobsNeibAlive (playerSpecs *p, int x, int y)
{                                 
  int n = 0;
  int i1, 
      i2, 
      ii1, 
      ii2, 
      loop1, 
      loop2;

  ii1 = MAX(y-1, 0);                 
  ii2 = MIN(y+1, MAX_POP-1); 
  i1 = MAX(x-1, 0);
  i2 = MIN(x+1, MAX_POP-1);

  for(loop1 = i1; loop1 <= i2; loop1++) 
    for(loop2 = ii1; loop2 <= ii2; loop2++)
      if (isAlive((*p)[loop1][loop2])) 
	n ++;
  
  if (n > 0) g_print ("microobsNeibAlive(%p,%d,%d)\n",p,x,y);
  if (isAlive((*p)[x][y])) 
    return (n-1);       
  else                  
    return n;
}

microobType dominationMicroobDynasty(playerSpecs *p, int x, int y)
{    
  int mR = 0, 
      mG = 0, 
      mB = 0, 
      mY = 0, 
      maxMicroobs = 0;
  int i1, i2, ii1, ii2, loop1, loop2;

  g_print ("dominationMicroobDynasty(%p,%d,%d)\n",p,x,y);
  ii1 = MAX(y-1, 0);
  ii2 = MIN(y+1, MAX_POP-1);
  i1 = MAX(x-1, 0);
  i2 = MIN(x+1, MAX_POP-1);

  for(loop1 = i1; loop1 <= i2; loop1++)
    for(loop2 = ii1; loop2 <= ii2; loop2++)
      if (isAlive((*p)[loop1][loop2])) {      
	if (!((loop1 == x) && (loop2 == y))) {  
	  switch ((*p)[loop1][loop2]) {
	    case mGreen : mG++; break;
	    case mBlue : mB++; break;
	    case mRed : mR++; break;
	    case mYellow : mY++; break;
	    case mDied : g_print ("General error has occured at life.c<dominationMicroobDynasty>\nAborting...\n"); abort(); break;
	}
      }
    }

  maxMicroobs = MAX(MAX(mR,mB),MAX(mG,mY));

  if (maxMicroobs == mG) return mGreen;
  else if (maxMicroobs == mB) return mBlue;
  else if (maxMicroobs == mY) return mYellow;
  else if (maxMicroobs == mR) return mRed;
  else {
    g_print ("Unexpect FATAL error at: life.c<dominationMicroobDynasty()>\nAborting...\n");
    abort();
  }
}

microobType next(playerSpecs *p, int x, int y)
{
  int alive = microobsNeibAlive(p,x,y); 
  
  g_print ("next(%p,%d,%d)\n",p,x,y);
  if (isAlive((*p)[x][y])) {     
    if ((alive == rulez.alive_min) || (alive == rulez.alive_max))
      return (*p)[x][y];          
    else
      return mDied;                
  }
  else {
    if ((alive == rulez.birth_min) || (alive == rulez.birth_max))
      return dominationMicroobDynasty(p, x, y); 
    else                                   
      return mDied;  
  }
}


gint copyPlayerSpecs(playerSpecs *p, playerSpecs *q)
{
  gint i=0, j=0;
  
  g_print ("copyPlayerSpecs(%p,%p)\n",p,q);
  for(i=0; i < MAX_POP; i++)
    for(j=0; j < MAX_POP; j++)
      (*p)[i][j] = (*q)[i][j];
  
  return 0;
}

playerSpecs *nextGeneration(playerSpecs *p)
{
  int i=0, ii=0;
  playerSpecs tmp; 
  levelOfGeneration++;
  
  g_print ("nextGeneration(%p,%d)\n",p,levelOfGeneration);
  for(i=0; i < MAX_POP; i++)
    for(ii=0; ii < MAX_POP; ii++)
      tmp[i][ii] = next(p, i, ii);

  copyPlayerSpecs (p, &tmp); 

  return p; 
}


gint comparePlayerSpecs(playerSpecs *p, playerSpecs *q)
{
   gint i, ii;
  
  g_print ("comparePlayerSpecs(%p,%p)\n",p,q);
  for(i=0; i < MAX_POP; i++)
    for(ii=0; ii < MAX_POP; ii++)
      if((*p)[i][ii] != (*q)[i][ii])
	return FALSE;
  
  return TRUE;
} 


gint life(gpointer data)
{
  copyPlayerSpecs(oldMicrobs, actMicrobs);
  addGeneration (&firstGen,actMicrobs);
  g_print ("life()\n");
  actMicrobs = nextGeneration(actMicrobs);

  if(infinityChecking)
    if(comparePlayerSpecs(old2Microbs, actMicrobs) || comparePlayerSpecs(oldMicrobs, actMicrobs)) {
      stopLifeSimulation (NULL,NULL); 
    }
      
  copyPlayerSpecs(old2Microbs, oldMicrobs);     

  return runningSimulation;
}

playerSpecs *previousGeneration(void)
{ 
  if (levelOfGeneration >= 1) {
    levelOfGeneration--;
    g_print ("previousGeneration(%d)\n",levelOfGeneration);
    return getLastGeneration (&firstGen);
  }
  else 
    return NULL;
}

generation *addGeneration (generation **first, playerSpecs *p)
{
  generation *newbie;
  newbie = malloc (sizeof(*newbie));
  if (!newbie) {
    g_print ("A general error has occured at life.c<addGeneration>\nAborting...\n");
    abort();
  }

  newbie->playerGeneration = malloc (sizeof(*(newbie->playerGeneration)));
  if (!(newbie->playerGeneration)) {
    g_print ("A general error has occured at life.c<addGeneration>\nAborting...\n");
    abort();
  }
  copyPlayerSpecs (newbie->playerGeneration,p);
  g_print ("addGeneration(%p,%p)\n",first,p);
  if (!first) {
    *first = newbie;
    (*first)->next = NULL;
  }
  else {
    newbie->next = *first;
    *first = newbie;
  }
  return newbie;
} 

playerSpecs *getLastGeneration (generation **first) {
  playerSpecs *p;
  generation *g;
  g_print ("getLastGeneration(%p)\n",first);
  p = (*first)->playerGeneration;
  g = *first;
  *first = (*first)->next;
  free (g);
  return p;
}