#include <gtk/gtk.h>
#include <stdlib.h>

#ifndef __LIFE_H
  #define __LIFE_H

#define MAX_POP 20  

#define DIED_MICROB	0x0
#define GREEN_MICROB	0x1
#define BLUE_MICROB	0x2
#define YELLOW_MICROB	0x4
#define RED_MICROB	0x8

typedef enum  {mDied = DIED_MICROB, 
		   mGreen=GREEN_MICROB,
		   mBlue=BLUE_MICROB,
                   mYellow=YELLOW_MICROB,
                   mRed=RED_MICROB} microobType;
		   
typedef microobType playerSpecs[MAX_POP][MAX_POP];
 
typedef struct coords {
	gint x;
	gint y;
}coords;

typedef struct rules {
  int alive_min,alive_max;
  int birth_min, birth_max;
} rules;

typedef struct generation {
  playerSpecs *playerGeneration;
  struct generation *next;
}generation;

playerSpecs *doomOfDeath (playerSpecs *p);
int mCount (microobType type, playerSpecs *p);		   
int saveMap (const char* filename);
playerSpecs *loadMap (const char* filename, playerSpecs *p);
playerSpecs *nextGeneration (playerSpecs *p);
playerSpecs *previousGeneration ();
gint life (gpointer data);
generation *addGeneration (generation **first, playerSpecs *p);
playerSpecs *getLastGeneration (generation **first);
gint copyPlayerSpecs (playerSpecs *p, playerSpecs *q);
#endif