#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <stdio.h>

#include "life.h"
#include "callbacks.h"
#include "interface.h"

const gchar* app_name = "Nightmare Conway Life Simulation Program v 0.0.1";

GtkWidget *window;

extern playerSpecs *actMicrobs;
extern playerSpecs *oldMicrobs;
extern playerSpecs *old2Microbs;
extern rules rulez;

int main (int argc, char **argv)
{
  
  gtk_init(&argc, &argv);

  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_signal_connect (GTK_OBJECT (window), "delete-event", GTK_SIGNAL_FUNC (deleteEvent), NULL);
  gtk_window_set_title (GTK_WINDOW (window), app_name);
 // gtk_widget_set_usize (GTK_WIDGET (window),400,450);
  gtk_widget_realize (window);
  
  rulez.alive_min = 2;
  rulez.alive_max = 3;
  rulez.birth_min = 3;
  rulez.birth_max = 3;
  
  actMicrobs = malloc (sizeof (*actMicrobs));
  oldMicrobs = malloc (sizeof (*oldMicrobs));
  old2Microbs = malloc (sizeof (*old2Microbs));
 
  if ((actMicrobs == NULL) || (oldMicrobs == NULL) || (old2Microbs == NULL)) { 
    g_print (" Error: initializing memory");
    abort();
  }
   
  actMicrobs = doomOfDeath (actMicrobs);
  oldMicrobs = doomOfDeath (oldMicrobs);
  
  initializatePixmaps(window);

  gtk_container_add (GTK_CONTAINER (window), createMainWindow(window));
  gtk_widget_show(window);
  
  gtk_main();
  
  return 0;
}
